#!/usr/bin/python
### GAD PIPELINE ###
## annotate_report_with_aberrant_expression_outrider.py
## Description : annotate a report file with outrider results
## Usage : python annotate_report_with_aberrant_expression_outrider.py -i <input file> -o <output file> -e <event file> -s <sample name>
## Output : an annotated report file including outrider annotation for aberrant expression
## Requirements : python 2.7

## Author : Emilie.Tisserant@u-bourgogne.fr, yannis.duffourd@u-bourgogne.fr
## Creation Date : 20170331
## last revision date : 20201020
## Known bugs : None

import os
import sys
import getopt

# Options
try:
    opts, args = getopt.getopt(sys.argv[1:], 'e:i:s:o:')
    for opt, arg in opts:
        if opt in ("-e"):
            event = arg
        elif opt in ("-i"):
            filein = arg
        elif opt in ("-s"):
            sample = arg
        elif opt in ("-o"):
            sys.stdout = open(arg, 'w')
except getopt.GetoptError:
    print 'usage : '
    sys.exit(1)


event_dict = {}
stream = open(event, 'r')
for line in stream:
    line = line.strip()
    tabs = line.split('\t')
    if not line.startswith('\"\"') and tabs[2].split("\"")[1] == sample:
        event_dict[tabs[1].split("\"")[1]]=tabs[5]
stream.close()


#Annotate variants
stream = open(filein, 'r')
i = 0
for line in stream:
    line = line.strip()
    tabs = line.split('\t')
    if not line.startswith('#'):
        genelist = []
        gl = tabs[i].split(",")
        tag = 0
        for g in gl:
            if g in event_dict:
                genelist.append("OUTRIDER:"+event_dict[g])
                tag += 1
            else:
                genelist.append(".")
        if tag > 0:
            print "\t".join(tabs[0:])+"\t"+",".join(genelist)
        else:
            print line+"\t."
    else:
        i = tabs.index("GeneList")
        print "\t".join(tabs[0:-1])+"\tOUTRIDER_zscore\tComments"
stream.close()
